//Door.cs
//writen by Ramen Sama


datablock AudioProfile(doorOpenSound)
{
   filename = "~/data/sound/doorOpen.wav";
   description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(doorCloseSound)
{
   filename = "~/data/sound/doorClose.wav";
   description = AudioClose3d;
	preload = false;
};

datablock StaticShapeData(door){
 	category = "Doors";
	//Points to the DTS object change this for your project
	shapeFile = "~/data/shapes/door/door_redZone.dts";
	position = "0 0 0";
	Scale="1 1 1";
	emap = true;
	receiveSunLight = "1";
 };

//Called when you touch the door
function door::onCollision(%this,%door,%col){
 	if (!%door.open){
 		%door.open=true;
		%door.setthreaddir(0,"true");
		%door.playthread(0,"open");
        serverPlay3D(doorOpenSound,%col.getTransform());
		%this.schedule(2000, close, %door,%col);
		}
 }
 
 
 
 function door::close(%this,%door,%col){

 //does a distance check between the door and what hit it last
//I have it set for 2... but you can use whatever you like

	%dist=VectorDist(%col.getposition(), %door.getposition());
	if (%dist > 2){
		%door.setthreaddir(0,"false");
        serverPlay3D(doorCloseSound,%col.getTransform());
		%door.open=false;
	}
	else
//if the player is too close, just go ahead and start the timer again
		%this.schedule(2000, close, %door,%col);
}

function door::onSearch(%this,%obj,%source){
//Searching will do the same as trying to open it
	%this.oncollision(%obj,%source);
 }


function door::make(){

	%pos = $wp.getnodetransform("door");
	%door = new staticshape(){ dataBlock = door; };
	%door.settransform(%pos);
	%door.open=false;
	%door.searchable=true;

	   new Trigger() {
      position = 	%pos = $wp.getnodeposition("exit");
      rotation = "1 0 0 0";
      scale = "3 1.5 3";
      dataBlock = "ExitTrigger";
      polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
	  };

	
	
	}




datablock TriggerData(exitTrigger)
{
   tickPeriodMS = 100;
};

function ExitTrigger::onEnterTrigger(%this,%trigger,%obj)
{
serverconnection.setblackout(true,500);
$canmove=false;
%loc = $wp.getnodetransform("start");


//Hack for battle
schedule(700,0,teleport,$player,%loc);

}


function ExitTrigger::oncreate(%this,%trigger,%obj)
{
error("I've been added to the world");

}


function teleport(%who, %where){
	%who.settransform(%where);


	//Hack for battle start
	battleprep();
	serverconnection.setblackout(false,700);
	return;
	
	
	$canmove=true;
}

function ExitTrigger::onLeaveTrigger(%this,%trigger,%obj)
{

}

function ExitTrigger::onTickTrigger(%this,%trigger)
{
}

