//-----------------------------------------------------------
//particle control data

datablock ParticleData(Bigfire0Particle)
{
    //----------Image variables---------------
    textureName = "~/data/shapes/particles/smoke"; //extension not needed

    useInvAlpha = 0;                    //default = "false"   

    inheritedVelFactor = 0.0;           //default = 0.0 
    constantAcceleration = 0.0;         //default = 0.0

    dragCoefficient = 0.9;              //default = 0.0  (must be >= 0.0)
    windCoefficient = 0.1;              //default = 1.0 
    gravityCoefficient = -0.2;          //default = 0.0  (negative rises)

    lifetimeMS = 2000.0;                //default = 1000 (minimum 100)  
    lifetimeVarianceMS = 50.0;          //default = 0.0  (must be < lifetimeMS)   

    spinSpeed = 0.0;                    //default = 0.0  (range -10000 to 10000 ; deg per second)
    spinRandomMax = 0.0;                //default = 0.0  (range -10000 to 10000)
    spinRandomMin = 0.0;                //default = 0.0  (range -10000 to 10000; < spinrandommax)

    //---------Interpolation variables--------
    times[0] = 0.0;
    times[1] = 0.33;
    times[2] = 0.66;
    times[3] = 1.0;
    colors[0] = "0.7 0.7 0.0 0.7";      //Red,Green,Blue,Intensity 
    colors[1] = "0.9 0.8 0.0 0.3";
    colors[2] = "0.8 0.8 0.0 0.2";
    sizes[0] = 4.0;
    sizes[1] = 0.5;
    sizes[2] = 0.2;
};
datablock ParticleData(Bigfire1Particle)
{
    //----------Image variables---------------
    textureName = "~/data/shapes/particles/smoke"; //extension not needed

    useInvAlpha = 0;                    //default = "false"   

    inheritedVelFactor = 0.0;           //default = 0.0 
    constantAcceleration = 0.0;         //default = 0.0

    dragCoefficient = 0.9;              //default = 0.0  (must be >= 0.0)
    windCoefficient = 0.1;              //default = 1.0 
    gravityCoefficient = -0.2;          //default = 0.0  (negative rises)

    lifetimeMS = 2000.0;                //default = 1000 (minimum 100)  
    lifetimeVarianceMS = 50.0;          //default = 0.0  (must be < lifetimeMS)   

    spinSpeed = 0.0;                    //default = 0.0  (range -10000 to 10000 ; deg per second)
    spinRandomMax = 0.0;                //default = 0.0  (range -10000 to 10000)
    spinRandomMin = 0.0;                //default = 0.0  (range -10000 to 10000; < spinrandommax)

    //---------Interpolation variables--------
    times[0] = 0.0;
    times[1] = 0.33;
    times[2] = 0.66;
    times[3] = 1.0;
    colors[0] = "0.9 0.7 0.0 0.7";      //Red,Green,Blue,Intensity 
    colors[1] = "1 0.8 0.0 0.3";
    colors[2] = "1 0.8 0.0 0.2";
    sizes[0] = 5.0;
    sizes[1] = 0.8;
    sizes[2] = 1;
};

datablock ParticleEmitterData(BigfireEmitter)
{
    ejectionPeriodMS = 10000; //1000 = 1 particle per second  (1ms minimum)
    periodVarianceMS = 500;   //variance has to be less than ejectionPeriodMS

    ejectionVelocity = 0.5;   // >= 0.0, from 1.0 to 3.0 meters per second
    velocityVariance = 0.0;   //has to be less than ejectionVelocity 
    ejectionOffset =   0.0;   //ejection start distance from the emitter point >=0

    //theta,phi rotation matrix axis angles (degrees) [eg. phi * (PI / 180)]
    thetaMax = 10.0;          //0-180 degrees
    thetaMin = 0.0;           //0-180 0 = All heights (min has to be less than max)
    phiReferenceVel = 180.0;  //0-360, 360=all directions
    phiVariance = 0.0;        //0-360
 
    overrideAdvances = 0;     //0 or 1   function ???

    //orients the particles out from the emitter source (1) or as billboard (0) 
    orientParticles= 1;       //0 or 1  "true" or "false"  
    orientOnVelocity = 0;     //0 or 1  billboard if no velocity in mission file

    //when tied to an ParticleEmitter object, then these work; 
    //if ParticleEmitterNode then don't need 
    //useEmitterSizes = 0;
    //useEmitterColors = 0;     //default = 0, has to be 0 for ParticleEmitterNode 

    particles = "Bigfire0Particle";  //call particle data 
    particles = "Bigfire1Particle";
};